package com.objis.demohibernate.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.objis.demohibernate.domaine.Event;
import com.objis.demohibernate.service.GestionnaireEvent;
import com.objis.demohibernate.util.HibernateUtil;


/**
 * Servlet implementation class EventManager
 */
public class EventManagerServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
private GestionnaireEvent gestionnaireEvent = new GestionnaireEvent();

    /**
     * Default constructor. 
     */
    public EventManagerServlet() {
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        try {
        	
        	// Prparer la sortie
            PrintWriter out = response.getWriter();
            out.println("<html><head><title>Event Manager</title></head><body>");

            // Rcuprer les paramtres soumis par l'utilisateur
            String eventTitle = request.getParameter("eventTitle");
            String eventDate = request.getParameter("eventDate");
            
            // Formatter la date
            SimpleDateFormat format_en  = new SimpleDateFormat("yyyy-MM-dd");
           // SimpleDateFormat format_fr  = new SimpleDateFormat("dd-MM-yyyy"); 
            Date date_en = format_en.parse(eventDate);
            
            // Validation sommaire
            if ( "".equals(eventTitle) || "".equals(eventDate) ) {
                out.println("<b><i>SVP entrer Evnement et Date.</i></b>");
            }
            else {
            	// Objet mtier Event
            	Event event = new Event(eventTitle,date_en);
                //APPEL Couche service pour gestion Evenement (CRUD)
            	Long id = gestionnaireEvent.creerEvent(event);
            	
            	int intId=id.intValue();
            	
            	String url ="<a href='RecupEventServlet?id="+ intId+"'>";
            	
            	// Informer utilisateur
                out.println("<b><i> Evnement ' <font color='red'>" + eventTitle + "</font>' dat du <font color='red'>" + eventDate + "</font> ajout en base de donnes avec cl primaire <font color='red'>"+ id + "</font> .</i></b>");
                out.println("<p><a href='/demoHibernateWebIntro'>Ajouter un autre vnement</a>.");
                out.println(url+"Modifier cet vnement</a>.");
                
                HttpSession httpSession = request.getSession();
                httpSession.setAttribute("evenementCourant", event);
                
            }

        }
        catch (Exception ex) {
            HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().rollback();
            if ( ServletException.class.isInstance( ex ) ) {
                throw ( ServletException ) ex;
            }
            else {
                throw new ServletException( ex );
            }
        }
    }

	

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	}

}
